using System;
using System.Data.Linq;
using Castle.DynamicProxy;
using Spring.Objects.Factory;

namespace DAODemo1
{
    public class DAOFactoryObject : IFactoryObject
    {
        public object GetObject()
        {
            return (new ProxyGenerator()).CreateProxy(GetDAOType(), new DAOInterceptor(ContextFactory), new object());
        }

        public Type ObjectType
        {
            get { return Type.GetType(DAOName); }
        }

        public bool IsSingleton
        {
            get { return false; }
        }

        private Type GetDAOType()
        {
            return Type.GetType(DAOName);
        }

        public IDataContextFactory ContextFactory { get; set; }
        public string DAOName { get; set; }
    }
}