using System.Linq;
using Castle.DynamicProxy;
using DAODemo1.Processors;

namespace DAODemo1
{
    public class DAOInterceptor : IInterceptor
    {
        private readonly IDataContextFactory ctxFactory;

        public DAOInterceptor(IDataContextFactory ctxFactory)
        {
            this.ctxFactory = ctxFactory;
        }

        public object Intercept(IInvocation invocation, params object[] args)
        {
            object[] attributes = invocation.Method.GetCustomAttributes(false);
            object result = null;
            attributes.ToList().ForEach(
                att => { result = ProcessorFactory.GetProcessor(att, invocation, ctxFactory).Process(args); });
            return result;
        }
    }
}